commit 6e183f821173c40ace8f034e430f4d9537a8a532
Author: freddy77 <freddy77>
Date:   Mon Jul 14 13:07:42 2008 +0000

    improve test for nvarchar

diff --git a/ChangeLog b/ChangeLog
index 29f3fd6..df3edfe 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Mon Jul 14 15:06:19 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/unittests/data.c: improve for nvarchar
+
 Mon Jul 14 10:14:29 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/prepare_query.c src/odbc/sql2tds.c:
 	- minor SQLWCHAR improves
@@ -428,4 +431,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2554 2008/07/14 08:14:47 freddy77 Exp $
+$Id: ChangeLog,v 1.2555 2008/07/14 13:07:42 freddy77 Exp $
diff --git a/src/odbc/unittests/data.c b/src/odbc/unittests/data.c
index 12e96bb..5f97a73 100644
--- a/src/odbc/unittests/data.c
+++ b/src/odbc/unittests/data.c
@@ -3,7 +3,7 @@
 
 /* Test various bind type */
 
-static char software_version[] = "$Id: data.c,v 1.15 2008/07/11 09:29:18 freddy77 Exp $";
+static char software_version[] = "$Id: data.c,v 1.16 2008/07/14 13:07:43 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int result = 0;
@@ -22,6 +22,8 @@ Test(const char *type, const char *value_to_convert, SQLSMALLINT out_c_type, con
 
 	/* execute a select to get data as wire */
 	sprintf(sbuf, "SELECT CONVERT(%s, '%s') AS data", type, value_to_convert);
+	if (strncmp(value_to_convert, "0x", 2) == 0)
+		sprintf(sbuf, "SELECT CONVERT(%s, %s) COLLATE Latin1_General_CI_AS AS data", type, value_to_convert);
 	Command(Statement, sbuf);
 	SQLBindCol(Statement, 1, out_c_type, out_buf, sizeof(out_buf), &out_len);
 	CHK(SQLFetch, (Statement));
@@ -112,6 +114,11 @@ main(int argc, char *argv[])
 			if (!old_result)
 				result = 0;
 		}
+
+		/* nvarchar without extended characters */
+		Test("NVARCHAR(20)", "test", SQL_C_CHAR, "4 test");
+		/* nvarchar with extended characters */
+		Test("NVARCHAR(20)", "0x830068006900f200", SQL_C_CHAR, "4 \x83hi\xf2");
 	}
 
 	Test("DECIMAL", "1234.5678", SQL_C_BINARY, "120001D3040000000000000000000000000000");

